/*
 * MATLAB Compiler: 4.6 (R2007a)
 * Date: Wed Nov 21 15:01:44 2007
 * Arguments: "-B" "macro_default" "-m" "-W" "main" "-T" "link:exe" "baps5"
 * "admix1" "calcGeneLengths" "linkage_admix" "admix2" "learn_simple_partition"
 * "addPoints" "initSpatialMultiMixture" "spatialMixture" "findCliques"
 * "spatialMix" "spatialPopMixture" "initSpatialMixture" "spatialMix_fixK"
 * "distance" "iconn" "noIndex" "seticon" "baps4cbf" "fixKWarning" "imageCbf"
 * "ownNum2Str" "wgetname" "goToFixedK" "image_figure" "setWindowOnTop"
 * "plotflow" "viewPartition4" "chooseDistance" "plotmodel" "viewPhylogeny"
 * "double2labels" "population_names_figure" "viewPopMixPartition" "giveColors"
 * "seqNeighJoin" "viewUnrooted" "graph2dot" "seqlinkage" "view_geneflow"
 * "graphvis2" "showColors" "view_admixture" "ksdensity_myown" "statgetargs"
 * "view_loglikelihood" "linkage" "viewDendrogram" "vorPlot" "mutationPlot"
 * "viewMixPartition" "waitALittle" "phyTreeRead" "viewPartition" "winontop"
 * "plotPhytree" "viewPartition2" "plotVarmuus" "viewPartition3" "greedyMix"
 * "indMix" "trainedMix" "greedyPopMix" "indMix_fixK" "CSEFlagDialog"
 * "i_encode_n" "readfasta" "allfreqsnew" "linkageMix" "selectDataType"
 * "allfreqsnew2" "linkageMix_fixK" "selectGene" "allfreqsnew3"
 * "linkageMixture_speed" "selectSeqType" "allfreqsnew4" "makecomplete"
 * "seqcode" "askSeq" "myCell2mat" "sumCell" "choosebox" "processprofile"
 * "transform2" "dendrogram_alpha" "processxls" "transform4" "encodealn"
 * "readbaps" "compare" "linkage_parallel" "spatial_parallel"
 * "greedyPopMix_parallel" "parallel" "uipickfiles" "independent_parallel"
 * "sort_partition" "initPopNames" "spatialPopMixture_parallel" "compare_admix"
 * "admix_parallel" "tulostaAdmixtureTiedot" "dispLine" "proportion2str"
 * "readScript" "goToPartitionCompare" "CSEFlagDialog1.m" "logml2String.m" "-d"
 * "E:\BAPS_release" 
 */

#include <stdio.h>
#include "mclmcr.h"
#ifdef __cplusplus
extern "C" {
#endif

extern mclComponentData __MCC_baps5_component_data;

#ifdef __cplusplus
}
#endif

static HMCRINSTANCE _mcr_inst = NULL;


#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultPrintHandler(const char *s)
{
    return mclWrite(1 /* stdout */, s, sizeof(char)*strlen(s));
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

#ifdef __cplusplus
extern "C" {
#endif

static int mclDefaultErrorHandler(const char *s)
{
    int written = 0;
    size_t len = 0;
    len = strlen(s);
    written = mclWrite(2 /* stderr */, s, sizeof(char)*len);
    if (len > 0 && s[ len-1 ] != '\n')
        written += mclWrite(2 /* stderr */, "\n", sizeof(char));
    return written;
}

#ifdef __cplusplus
} /* End extern "C" block */
#endif

/* This symbol is defined in shared libraries. Define it here
 * (to nothing) in case this isn't a shared library. 
 */
#ifndef LIB_baps5_C_API 
#define LIB_baps5_C_API /* No special import/export declaration */
#endif

LIB_baps5_C_API 
bool MW_CALL_CONV baps5InitializeWithHandlers(
    mclOutputHandlerFcn error_handler,
    mclOutputHandlerFcn print_handler
)
{
    if (_mcr_inst != NULL)
        return true;
    if (!mclmcrInitialize())
        return false;
    if (!mclInitializeComponentInstance(&_mcr_inst,
                                        &__MCC_baps5_component_data,
                                        true, NoObjectType, ExeTarget,
                                        error_handler, print_handler))
        return false;
    return true;
}

LIB_baps5_C_API 
bool MW_CALL_CONV baps5Initialize(void)
{
    return baps5InitializeWithHandlers(mclDefaultErrorHandler,
                                       mclDefaultPrintHandler);
}

LIB_baps5_C_API 
void MW_CALL_CONV baps5Terminate(void)
{
    if (_mcr_inst != NULL)
        mclTerminateInstance(&_mcr_inst);
}

int run_main(int argc, const char **argv)
{
    int _retval;
    /* Generate and populate the path_to_component. */
    char path_to_component[(PATH_MAX*2)+1];
    separatePathName(argv[0], path_to_component, (PATH_MAX*2)+1);
    __MCC_baps5_component_data.path_to_component = path_to_component; 
    if (!baps5Initialize()) {
        return -1;
    }
    _retval = mclMain(_mcr_inst, argc, argv, "baps5", 0);
    if (_retval == 0 /* no error */) mclWaitForFiguresToDie(NULL);
    baps5Terminate();
    mclTerminateApplication();
    return _retval;
}

int main(int argc, const char **argv)
{
    if (!mclInitializeApplication(
        __MCC_baps5_component_data.runtime_options,
        __MCC_baps5_component_data.runtime_option_count))
        return 0;
    
    return mclRunMain(run_main, argc, argv);
}
